package com.sa.ibiz.demo.demo.service.dto;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.ibizutil.domain.ParentData;
import com.sa.ibiz.demo.demo.domain.WFStepActor;
import org.springframework.util.StringUtils;
import lombok.Data;
import java.util.Map;
import java.sql.Timestamp;
import com.sa.ibiz.demo.ibizutil.service.SearchFilterBase;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.sa.ibiz.demo.ibizutil.helper.DataGridCustomSearchHelper;
import com.alibaba.fastjson.JSONObject;
@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class WFStepActorSearchFilter extends SearchFilterBase {

	private String query;
	private Page page;
	private QueryWrapper<WFStepActor> selectCond;
	private JSONObject customsearchval;
	public WFStepActorSearchFilter(){
		this.page =new Page<WFStepActor>(1,Short.MAX_VALUE);
		this.selectCond=new QueryWrapper<WFStepActor>();	
	}

	/**
	 * 设定自定义查询条件，在原有SQL基础上追加该SQL
	 */
	public void setCustomCond(String sql)
	{
		this.selectCond.apply(sql);
	}

	private String n_originalwfuserid_eq;

	public void setN_originalwfuserid_eq(String n_originalwfuserid_eq) {
        this.n_originalwfuserid_eq = n_originalwfuserid_eq;
        if(!StringUtils.isEmpty(this.n_originalwfuserid_eq)){
            this.selectCond.eq("originalwfuserid", n_originalwfuserid_eq);
        }
    }
	private String n_originalwfusername_eq;

	public void setN_originalwfusername_eq(String n_originalwfusername_eq) {
        this.n_originalwfusername_eq = n_originalwfusername_eq;
        if(!StringUtils.isEmpty(this.n_originalwfusername_eq)){
            this.selectCond.eq("originalwfusername", n_originalwfusername_eq);
        }
    }
	private String n_originalwfusername_like;

	public void setN_originalwfusername_like(String n_originalwfusername_like) {
        this.n_originalwfusername_like = n_originalwfusername_like;
        if(!StringUtils.isEmpty(this.n_originalwfusername_like)){
            this.selectCond.like("originalwfusername", n_originalwfusername_like);
        }
    }
	private String n_wfstepactorname_like;

	public void setN_wfstepactorname_like(String n_wfstepactorname_like) {
        this.n_wfstepactorname_like = n_wfstepactorname_like;
        if(!StringUtils.isEmpty(this.n_wfstepactorname_like)){
            this.selectCond.like("wfstepactorname", n_wfstepactorname_like);
        }
    }
	private String n_wfstepid_eq;

	public void setN_wfstepid_eq(String n_wfstepid_eq) {
        this.n_wfstepid_eq = n_wfstepid_eq;
        if(!StringUtils.isEmpty(this.n_wfstepid_eq)){
            this.selectCond.eq("wfstepid", n_wfstepid_eq);
        }
    }
	private String n_wfstepname_eq;

	public void setN_wfstepname_eq(String n_wfstepname_eq) {
        this.n_wfstepname_eq = n_wfstepname_eq;
        if(!StringUtils.isEmpty(this.n_wfstepname_eq)){
            this.selectCond.eq("wfstepname", n_wfstepname_eq);
        }
    }
	private String n_wfstepname_like;

	public void setN_wfstepname_like(String n_wfstepname_like) {
        this.n_wfstepname_like = n_wfstepname_like;
        if(!StringUtils.isEmpty(this.n_wfstepname_like)){
            this.selectCond.like("wfstepname", n_wfstepname_like);
        }
    }

	public void setSrfparentdata(Map<String, String> srfparentdata) {
		this.srfparentdata = srfparentdata;
		String strParentkey=this.getSrfparentdata().get("srfparentkey");
		if(this.srfparentdata.containsKey("srfparentmode")&& this.getSrfparentdata().get("srfparentmode").equals("DER1N_WFSTEPACTOR_WFUSER_ORIGINALWFUSERID"))
			if(StringUtils.isEmpty(strParentkey)){
				this.setN_originalwfuserid_eq("NA");
			}
			else{
				this.setN_originalwfuserid_eq(strParentkey);
			}
		if(this.srfparentdata.containsKey("srfparentmode")&& this.getSrfparentdata().get("srfparentmode").equals("DER1N_WFSTEPACTOR_WFSTEP_WFSTEPID"))
			if(StringUtils.isEmpty(strParentkey)){
				this.setN_wfstepid_eq("NA");
			}
			else{
				this.setN_wfstepid_eq(strParentkey);
			}
	}

	/**
	 * 启用快速搜索
	 */
	public void setQuery(String query)
	{
		 this.query=query;
		 if(!StringUtils.isEmpty(query)){
			this.selectCond.or().like("wfstepactorname",query);
		 }
	}

	/**
	 * 自定义查询
	 * @param customsearchval
	 */
	public void setCustomsearchval(JSONObject customsearchval) {
		this.customsearchval = customsearchval;
		if(!StringUtils.isEmpty(customsearchval)){
			DataGridCustomSearchHelper customSearchHelper= DataGridCustomSearchHelper.getInstance();
			String customSql =customSearchHelper.parseCustomVal(customsearchval);
			this.selectCond.apply(customSql);
		}
	}

}